unit APM;

{***$*M 8192,8192,200000}           { Leave memory for child process }
{$D-}
{$L-}
{* $* G+}
{* $* N+}

interface
  function CheckAPM(var s_vers: string): boolean;
  function TurnOff: boolean;


implementation

function BCD2Str(val: byte): string;
const
  BCD: array[0..9] of char = ('0','1','2','3','4','5','6','7','8','9');
var
  s_tmp: string;
begin
  s_tmp:= '';
  if (val shr 4)> 0 then
    s_tmp:= BCD[(val shr 4)];
  s_tmp:= s_tmp+ BCD[(val and $0F)];
  BCD2Str:= s_tmp;
end;

function CheckAPM(var s_vers: string): boolean;
label
  l_ok,l_er;
var
  res: boolean;
  ww1: word;
begin
  res:= true;
  s_vers:= '';
  asm
    mov ax,5300h      { Get Version }
    xor bx,bx
    int 15h
    jc l_er
    cmp bx,504Dh
    jz l_ok
l_er:
    mov res,0
l_ok:
    mov ww1,ax
{    mov ww2,cx}
  end;
  if res then
    begin
      s_vers:= BCD2Str(ww1 shr 8)+'.'+BCD2Str(ww1);
    end;
  CheckAPM:= res;
end;

function TurnOff: boolean;
label
  d1_,Error_,Done_;
var
  res: boolean;
begin
  res:= true;
  asm
	mov	ax,5300h	{ * Get APM version }
	xor	bx,bx
	int	15h
	jc	Error_
	push	ax

	mov	ax,5301h	{ * Connect interface }
	xor	bx,bx
	int	15h
	jnc	d1_
	mov	ax,5304h	{ * Disconnect interface }
	xor	bx,bx
	int	15h

	mov	ax,5301h		{ * Connect to real mode interface }
	xor	bx,bx
	int	15h
    jnc d1_
    pop ax
    jmp Error_

d1_:
	mov	ax,530Eh		{ * APM driver version (Connect to BIOS) }
	xor	bx,bx
	pop	cx
	int	15h
    jc Error_

	mov	ax,530Dh		{ * Enable Device PM }
	mov	bx,1
	mov	cx,bx		{ enable it }
	int	15h

	mov	ax,530Fh		{ * Engage PM }
	mov	bx,1
	mov	cx,bx		{ engage it }
	int	15h

	mov	ax,5308h		{ * Enable PM }
	mov	bx,0FFFFh
	mov	cx,1		{ enable it }
	int	15h

	mov	ax,5307h		{ * Set power state }
	mov	bx,1
	mov	cx,3		{ state = off }
	int	15h
    jnc Done_

Error_:
	mov	ax,5304h		{ * Disconnect interface }
	xor	bx,bx
	int	15h
    mov res,0
Done_:
  end;
  TurnOff:= res;
end;

{------------------------------------------------------------}

begin

end.

