program down;

{$M 8192,8192,200000}           { Leave memory for child process }

{$D-}
{$L-}
{$Y-}
{$I-}

{$G+}
{$N+}

uses Dos,Crt,WinCrt,Disp,Fnames, APM{,DRIVERS};

type
  TNow = record
    DoW,Hour,Min: word;
  end;

const
  _ecEXIT       = 0;
  _ecRUN        = 10;
{  _XX           = 42;}
  _YY           = 9;

  MonthStr: array[1..12] of string[8] = (
    'ﭢ', '䥢ࠫ', '', '५', '', '',
    '', '', 'ᥭ', '', '', '');
  WeekStr: array[0..6] of string[11] = (
    'ᥭ','쭨', '୨', '।', '⢥', '⭨', '㡡'
    );

  _NormalColor = (White+ LightBlue*16);
  _BorderColor = (Blue+ LightBlue*16);
  _TitleColor  = (LightCyan+ LightBlue*16);
  _DarkColor   = (Black+ LightBlue*16);
  _LightColor  = (Yellow + LightBlue *16);

  _LoColor       = (Black+ LightBlue*16);
  _HiColor       = (Red+ LightBlue*16);

  _DOSColor      = (LightGray+ Black *16);


  CNone   = ^A;
  CEnter  = ^B;
  CExit   = ^I;

var
  _XX: integer;
  DownTime,DownTimer: longint;
  DownTimeOld: word;
  Ch: char;
  bFont,bSound: boolean;
  WelcomeStr: string;
  Now: TNow;

  OrigVMode: Integer;
{-----------------------------------------------------------}
function uppercase(s: string): string; forward;
function replicate(Sym: char; CountSym: integer): string; forward;
procedure Beep; forward;
procedure Peep; forward;
function  ReadChar: Char; forward;
procedure ShowInfo; forward;
procedure CopyRight; forward;
procedure StrToTime(ss: string; var tt: TNow); forward;
function cmpStrToTime(ss: string; hh,mm: integer): integer; forward;
function cmpTime(t1,t2: TNow): integer; forward;
{-----------------------------------------------------------}

function uppercase(s: string): string;
var
  i: integer;
  sr: string;
begin
  sr:= s;
  for i:= 1 to length(s) do
    sr[i] := upcase(s[i]);
  uppercase:= sr;
end;

procedure FlushDisk;
label
  hdloop_;
begin
  asm
	mov    ah,0Dh
	int    21h		    { Flush disk buffers to disk }
	push   ds
	xor    cx,cx
	mov    ds,cx
	mov    cl,ds:[475h] { HDisk counter }
	pop    ds
	mov    dl,80h
hdloop_:
	mov    ah,0
	int    13h		    { Reset disk, dl=drive }
	inc    dx
	loop   hdloop_
  end;
end;

procedure GetNow;
var
  d,s,hu: Word;
begin
  with Now do
    begin
      GetDate(hu,s,d,Dow);
      GetTime(Hour,Min,s,hu);
      if DoW= 0 then
        DoW:= 7;
    end;
end;

function ScanParam(s: string; var posi: integer ): integer;
var
  i,j: integer;
begin
  ScanParam:= 0;
  for i:= 1 to paramcount do
    begin
      j:= pos(uppercase(s),uppercase(paramstr(i)));
      if j> 0 then
        begin
          ScanParam:= i;
          posi:= i; {j;}
          break;
        end;
  end;
end;

function ReadChar: Char;
begin
  if KeyPressed then
    begin
      Ch:= ReadKey;
      if Ch = #0 then
        begin
          Ch:= ReadKey;
          case Ch of
            #45: Ch:= CExit;     { Alt-X }
            #13: Ch:= CEnter;
          end;
        end
      else
        case Ch of
          #27:  Ch:= CExit;
          #13:  Ch:= CEnter;
          ' ':  Ch:= CEnter;
        end;
    end
  else
    Ch:= CNone;
  ReadChar:= Ch;
end;
{+++++++++++++++++++++++++++++++++++++++++++++++++}
function IntToStr(I: Longint): String;
var
 S: string[11];
begin
 Str(I, S);
 IntToStr := S;
end;
{+++++++++++++++++++++++++++++++++++++++++++++++++}
function StrToInt(s: string): integer; {longint;}
var
  i,Code: Integer;
begin
  val(s,i,Code);
  if Code<> 0 then
    StrToInt:= -1
  else
    StrToInt:= i;
end;
{+++++++++++++++++++++++++++++++++++++++++++++++++}
function StrToVal(s: string): word;
var
  i,Code: Integer;
begin
  val(s,i,Code);
  StrToVal:= i;
end;
{+++++++++++++++++++++++++++++++++++++++++++++++++}
function Replicate(Sym: char; CountSym: integer): string;
var
   I: integer;
   S: string;
begin
  S:= '';
  for I := 1 to CountSym do
      insert(Sym, S, 1);
  Replicate:= S;
end;
{+++++++++++++++++++++++++++++++++++++++++++++++++}
procedure Beep;
var
  i: integer;
begin
  if bSound then
    begin
      for i:= 1 to 3 do
        begin
          Sound(880); Delay(50);
          Sound(330); Delay(50);
          Sound(440); Delay(70);
        end;
      NoSound;
    end;
end;
{+++++++++++++++++++++++++++++++++++++++++++++++++}
procedure Peep;
begin
  if bSound then
    begin
      Sound(880); Delay(50);
      Sound(440); Delay(50);
      NoSound;
    end;
end;
{+++++++++++++++++++++++++++++++++++++++++++++++++}
function LeadingZero(w : Word) : String;
var
  s : String;
begin
  Str(w:0,s);
  if Length(s) = 1 then
    s := '0' + s;
  LeadingZero := s;
end;

procedure WriteCenter(yy: byte;sss: string;color: byte);
var
  PosiX: integer;
  s: string;
begin
  s:= sss;
  PosiX:= 1;
  if length(s)<= _XX then
    PosiX:= 1+(_XX-length(s)) div 2
  else
    s:= copy(s,1+(length(s)-_XX) div 2,_XX);
  WriteToWindow(PosiX,yy,s,color);
end;

procedure ShowInfo;
var
  sInfo: string;
  h,m,s,hu: Word;
begin
  GetTime(h,m,s,hu);
  sInfo:= IntTostr{LeadingZero}(h)+':'+LeadingZero(m); {+':'+LeadingZero(s); +'.'+LeadingZero(hund);}
  GetDate(h,m,s,hu);
  sInfo:= sInfo+', '+WeekStr[hu]+', '+IntToStr(s)+' '+ MonthStr[m]+' '+LeadingZero(h)+ ' .';
  WriteCenter(1,sInfo,_LightColor);
  WriteCenter(3,'   '+WelcomeStr+' '+IntToStr(DownTimer)+' ᥪ.   ',_NormalColor);
end;

procedure ShowProgress;
begin
  WriteToWindow(2,4,replicate('',round(((_XX-2) / DownTime)* (DownTime- DownTimer))),_HiColor);
end;

procedure CreateWorkSpace;
var
  i: integer;
  s: string;
begin
  _XX:= 42;
  OrigVMode:= LastMode;
  if ScanParam('/G',i) > 0 then
    begin
      TextMode(CO40);
      _XX:= 40;
      WelcomeStr:= '몫祭  १';
    end
  else
    WelcomeStr:= ' 㤥 몫祭 १';
  SetBlink(OFF);
  SetCursor(OFF);
  if bFont then
    LoadFont;
  MaxX:= Lo(windMax) +1;
  MaxY:= Hi(windMax) +1;
  OpenWindow(1+(maxX-_XX) div 2,1+(maxY-_YY) div 2,
              _XX+(maxX-_XX) div 2,_YY+(maxY-_YY) div 2,
              '',_NormalColor,_TitleColor,_BorderColor);
  _XX:= _XX-2;
  WriteToWindow(2,4,replicate('',_XX-2),_LoColor);
  WriteCenter(6,' , ⮡ ᤥ ',_TitleColor);
  WriteCenter(7,',  ESCAPE  ⬥.',_TitleColor);
end;
{+++++++++++++++++++++++++++++++++++++++++++++++++}
procedure CloseWorkSpace;
begin
  CloseWindow;
  if OrigVMode<> LastMode then
    TextMode(OrigVMode);
  SetBlink(ON);
  SetCursor(ON);
  TextAttr:= _DOSColor;
{  ClrScr; }
end;
{+++++++++++++++++++++++++++++++++++++++++++++++++}
function CheckTime: boolean;
var
  h,m,s,hund: word;
begin
  GetTime(h,m,s,hund);
  if DownTimeOld<> s then
    begin
      DownTimeOld:= s;
      dec(DownTimer);
      ShowProgress;
      Peep;
      ShowInfo;
    end;
  CheckTime:= (DownTimer= 0);
end;

procedure ProcessMessages;
var
  bBreak: boolean;
begin
  bBreak:= false;
  DownTimeOld:= 61;
  repeat
    Ch:=ReadChar;
    case Ch of
         CExit:  bBreak:= true;
         CEnter: begin
		            bBreak:= true;
                    DownTimer:= 0;
                 end;
    else
      bBreak:= CheckTime;
    end;
  until bBreak;
  if (DownTimer= 0) then
    delay(600);
end;
{---}
procedure CopyRight;
var
  s_tmp: string;
begin
  writeln('ATX Down 1.3');
  writeln('(C) 1999 by Sergey Kirichenko (ksv@cheerful.com)');
  if CheckAPM(s_tmp) then
    writeln('㦥 BIOS APM ᨨ '+s_tmp)
  else
    writeln('BIOS APM  㦥');
  writeln('');
end;

function CheckParam: boolean;
var
  bok: boolean;
  FirstD,i,j: integer;
  FirstT,LastT: TNow;
  s_tmp: string;
begin
  if ScanParam('/?',j)> 0 then
    begin
      writeln(' ᯮ짮: '+extractfilename(paramstr(0))+' [/]');
      writeln('   樨:');
      writeln('   d:[_]  -  /   ');
      writeln('                     (᫨  㪠 =  )');
      writeln('   t:[६]       - ६ /  ६');
      writeln('                     (᫨  㪠 =  ६)');
      writeln('   w:[㧠]       - প 몫祭  ᥪ㭤');
      writeln('                     (᫨  㪠 = 15)');
      writeln('   s               -  ');
      writeln('   f               -  㧨 ᪨ ');
      writeln('   g               - 訥 㪢');
      writeln('');
      writeln(' ਬ:');
      writeln('  몫  १ 5 ᥪ㭤, ᫨ ணࠬ 饭  㡡');
      writeln('   ᥭ  8:30  10 ᮢ : '+extractfilename(paramstr(0))+' /d:6,7 /t:8:30-10 /w:5');
      writeln('');
      CheckParam:= false;
      exit;
    end;
  bSound:= (ScanParam('/S',j)= 0);
  bFont:= (ScanParam('/F',j)= 0);
  if ScanParam('/D:',j)> 0 then         {valid day of week}
    begin
      s_tmp:= copy(paramstr(j),4,100);
      bok:= false;
      while length(s_tmp)> 0 do
        if ((pos(',',s_tmp)> 0) and (pos('-',s_tmp)=0)) or
           ((pos(',',s_tmp)> 0) and (pos(',',s_tmp)< pos('-',s_tmp))) then
          if StrToInt(copy(s_tmp,1,pos(',',s_tmp)-1))= Now.DoW then
            begin
              bok:= true;
              break;
            end
          else
            s_tmp:= copy(s_tmp,pos(',',s_tmp)+1,100)
        else
          if pos('-',s_tmp)> 0 then
            begin
              if StrToInt(copy(s_tmp,1,pos('-',s_tmp)-1))> 0 then
                FirstD:= StrToInt(copy(s_tmp,1,pos('-',s_tmp)-1))
              else
                FirstD:= 1;
              s_tmp:= copy(s_tmp,pos('-',s_tmp)+1,100);
              if pos(',',s_tmp)> 0 then
                i:= pos(',',s_tmp)
              else
                i:= 100;
              j:= StrToInt(copy(s_tmp,1,i-1));
              if j< 0 then                    {!}
                j:= 7;
              s_tmp:= copy(s_tmp,i+1,100);
              if (Now.Dow>= FirstD) and (Now.Dow<= j) then
                begin
                  bok:= true;
                  break;
                end;
            end
          else
            begin
              bok:= StrToInt(s_tmp)= Now.DoW;
              s_tmp:= '';
            end;
    end;
  if not bok then
    begin
      writeln('室騩 .');
      CheckParam:= false;
      exit;
    end;
  if ScanParam('/T:',j)> 0 then         {valid time}
    begin
      s_tmp:= copy(paramstr(j),4,100);
      bok:= false;
      while length(s_tmp)> 0 do
        if ((pos(',',s_tmp)> 0) and (pos('-',s_tmp)=0)) or
           ((pos(',',s_tmp)> 0) and (pos(',',s_tmp)< pos('-',s_tmp))) then
          if cmpStrToTime(copy(s_tmp,1,pos(',',s_tmp)-1),Now.Hour,Now.Min)=0 then
            begin
              bok:= true;
              break;
            end
          else
            s_tmp:= copy(s_tmp,pos(',',s_tmp)+1,100)
        else
          if pos('-',s_tmp)> 0 then
            begin
              if cmpStrToTime(copy(s_tmp,1,pos('-',s_tmp)-1),0,0)> 0 then
                StrToTime(copy(s_tmp,1,pos('-',s_tmp)-1),FirstT)
              else
                StrToTime('0',FirstT);
              s_tmp:= copy(s_tmp,pos('-',s_tmp)+1,100);
              if pos(',',s_tmp)> 0 then
                i:= pos(',',s_tmp)
              else
                i:= 100;
              StrToTime(copy(s_tmp,1,i-1),LastT);
              if (LastT.Hour=0) and (LastT.Min=0) then
                StrToTime('24',LastT);
              s_tmp:= copy(s_tmp,i+1,100);
              if (cmpTime(Now,FirstT)>=0) then
                if (cmpTime(Now,LastT)<=0) then
                  begin
                    bok:= true;
                    break;
                  end;
            end
          else
            begin
              bok:= cmpStrToTime(s_tmp,Now.Hour,Now.Min)= 0;
              s_tmp:= '';
            end;
    end;
  if not bok then
    begin
      writeln('室饥 ६.');
      CheckParam:= false;
      exit;
    end;
  DownTime:= -1;
  if ScanParam('/W:',j)> 0 then         {time-out}
    DownTime:= StrToInt(copy(paramstr(j),4,4));
  if DownTime< 0 then
    DownTime:= 15;

  CheckParam:= bok;
end;

procedure StrToTime(ss: string; var tt: TNow);
var
  i: integer;
begin
  if pos(':',ss)> 0 then
    i:= pos(':',ss)
  else
    i:= length(ss)+1;
  tt.Hour:= StrToVal(copy(ss,1,i-1));
  tt.Min:= StrToVal(copy(ss,i+1,length(ss)));
end;

function cmpStrToTime(ss: string; hh,mm: integer): integer;
var
  tt: TNow;
begin
  StrToTime(ss,tt);
  if tt.Hour<> hh then
    cmpStrToTime:= tt.Hour- hh
  else
    cmpStrToTime:= tt.Min- mm;
end;

function cmpTime(t1,t2: TNow): integer;
var
  i: integer;
begin
  if t1.Hour<> t2.Hour then
    i{cmpTime}:= integer(t1.Hour)- integer(t2.Hour)
  else
    i{cmpTime}:= integer(t1.Min)- integer(t2.Min);
  cmpTime:= i;
end;


(*
{*$*F+,S-,W-}
procedure CBreakHandler; interrupt;
begin
  asm
    iret
  end;
end;
{*$*F-,S+}

procedure HoldCBreak;
var
  CBreakSave: pointer;
  PSPseg: word;
begin
  SetIntVec($23,Addr(CBreakHandler));
end;
*)
{------------------------------------------------------------}
begin
  CopyRight;
{  CtrlBreakHit:= False;
  HoldCBreak;
}
  SetCBreak(false);
  GetNow;
  if CheckParam then
    if CheckAPM(WelcomeStr) then
      begin
        DownTimer:= DownTime;
        if DownTimer> 0 then
          begin
            CreateWorkSpace;
            DownTimeOld:= 0;
            ProcessMessages;
            CloseWorkSpace;
          end;
        if DownTimer= 0 then
          begin
            Beep;
            writeln('࠭ ᪮ ஢.');
            FlushDisk;
            writeln('몫祭.');
            TurnOff;
          end
        else
          writeln('몫祭 ࢠ  ॡ.');
      end
    else
      writeln('ࠢ ⠭  .');
  halt(0);
end.
