unit WinCrt;

{$D-,S-}

interface

uses Dos,Crt,Win;

type
  TitleStrPtr = ^TitleStr;
  WinRecPtr = ^WinRec;
  WinRec = record
			Next: WinRecPtr;
			State: WinState;
			Title: TitleStrPtr;
			TitleAttr, FrameAttr: Byte;
			Buffer: Pointer;
  		  end;
var
  TopWindow: WinRecPtr;
  WindowCount: Integer;
  MaxX, MaxY : byte;
{-----------------------------------------------------------}

procedure ActiveWindow(Active: Boolean);
procedure OpenWindow(X1, Y1, X2, Y2: Byte; T: TitleStr;
  MAttr, TAttr, FAttr: Byte);
procedure CloseWindow;
procedure Initialize;
procedure WriteToScreen(X, Y: Byte; S: String; Attr: Byte);
procedure WriteToWindow(X, Y: Byte; S: String; Attr: Byte);
{+++++++++++++++++++++++++++++++++++++++++++++++++}

implementation

procedure WriteToWindow(X, Y: Byte; S: String; Attr: Byte);
begin
  WriteStr(X,Y,S,Attr);
end;

procedure WriteToScreen(X, Y: Byte; S: String; Attr: Byte);
var
  SaveWindMin, SaveWindMax: Word;
{  SaveWhereX, SaveWhereY: Byte;
  SaveAttr: byte;}
begin

  SaveWindMin:= WindMin;
  SaveWindMax:= WindMax;
{  SaveWhereX:= WhereX;
  SaveWhereY:= WhereY;
  SaveAttr:= TextAttr;}
  window(1,1,maxX,maxY);
  gotoXY(X,Y);
{  TextAttr:= Attr;}
 WriteStr(X,Y,S,Attr);

{  TextAttr:= SaveAttr;}
  Window(lo(SaveWindMin)+1,hi(SaveWindMin)+1,lo(SaveWindMax)+1,hi(SaveWindMax)+1);
{  gotoXY(SaveWhereX,SaveWhereY);}
end;

procedure ActiveWindow(Active: Boolean);
begin
  if TopWindow <> nil then
  begin
    UnFrameWin;
    with TopWindow^ do
      if Active then
        FrameWin(Title^, PaneleFrame, TitleAttr, FrameAttr)
      else
        FrameWin(Title^, SingleFrame, FrameAttr, FrameAttr);
  end;
end;
{+++++++++++++++++++++++++++++++++++++++++++++++++}
procedure OpenWindow(X1, Y1, X2, Y2: Byte; T: TitleStr;
  MAttr, TAttr, FAttr: Byte);
var
  W: WinRecPtr;
begin
  ActiveWindow(False);
  New(W);
  with W^ do
  begin
    Next := TopWindow;
    SaveWin(State);
    GetMem(Title, Length(T) + 1);
    Title^:= T;
    TitleAttr:= TAttr;
    FrameAttr:= FAttr;
    Window(X1, Y1, X2, Y2);
    GetMem(Buffer, WinSize);
    ReadWin(Buffer^);
    FrameWin(T, PaneleFrame, TAttr, FAttr);

  end;
  TopWindow := W;
  Inc(WindowCount);
  FillWin(' ',MAttr);
end;
{+++++++++++++++++++++++++++++++++++++++++++++++++}
procedure CloseWindow;
var
  W: WinRecPtr;
begin
  if TopWindow <> nil then
  begin
    W := TopWindow;
    with W^ do
    begin
      UnFrameWin;
      WriteWin(Buffer^);
      FreeMem(Buffer, WinSize);
      FreeMem(Title, Length(Title^) + 1);
      RestoreWin(State);
      TopWindow := Next;
    end;
    Dispose(W);
    ActiveWindow(True);
    Dec(WindowCount);
  end;
end;
{+++++++++++++++++++++++++++++++++++++++++++++++++}
procedure Initialize;
begin
  TopWindow := nil;
  WindowCount := 0;
end;
{+++++++++++++++++++++++++++++++++++++++++++++++++}

{ $ L WIN}

begin
    MaxX:= Lo(windMax) +1;
    MaxY:= Hi(windMax) +1;
	Initialize;
end.
